#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int
main (void)
{
  char buf[1024];
  int err = getlogin_r (buf, sizeof buf);
  printf ("err = %d\n", err);

  {
    char smallbuf[1024];

    err = getlogin_r (smallbuf, 0);
    printf ("err = %d\n", err);
    printf ("    = %s\n", strerror (err));

    err = getlogin_r (smallbuf, 1);
    printf ("err = %d\n", err);
    printf ("    = %s\n", strerror (err));

    err = getlogin_r (smallbuf, 2);
    printf ("err = %d\n", err);
    printf ("    = %s\n", strerror (err));

    fflush (stdout);

    if (!(err == ERANGE || err == EINVAL)) abort ();
  }

  return 0;
}
